<?php
namespace EMS\PortalFuncionario\Geral\Services;

use EMS\PortalFuncionario\Util\HcmServices;
use EMS\PortalFuncionario\Geral\Repository\ParamOrgRepository;

class ParamOrgService {

    /** @var HcmServices */
    protected $hcmServices;

    /** @var ParamOrgRepository */
    protected $paramOrgRepository;

    public function __construct(
        HcmServices $hcmServices,
        ParamOrgRepository $paramOrgRepository
    ) {
        $this->hcmServices = $hcmServices;
        $this->paramOrgRepository = $paramOrgRepository;
    }

    public function getValorReferencia(
        array $row
    ) {
        $nrOrg = (int) $row['NRORG'];

        $hcmServicesRoute = 'getValorReferencia';

        $params = [
            'requestType' => 'Row',
            'row' => $row,
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $valor = $response['dataset'][$hcmServicesRoute]['valor'];

        return $valor;
    }

    public function getNrColetorFuncionario(
        int $nrOrg
    ) {
        $paramOrg = $this->paramOrgRepository->getParamOrg($nrOrg);
        return $paramOrg['NRCOLETORFUNCIO'] ?? null;
    }
}
